setNameTemp = set()

#this script needs (see further down):
#-downloaded version of the Brenda database #you could get this download for some time for free, but not anymore, as it seems
#-a tab delimited file of all proteins with their already assigned EC numbers (from Interpro, Priam, or wherever)
#-interpro output, for name matching against Brenda

#note: this was never meant to be published, code is therefore a mess, but should be readable and usable in the current state, if the correct input is provided

def processString(sName,bBrenda=False):
    sName = sName.lower()    
    sName = sName.replace("domain","")
    #sName = sName.replace("protein","") #leads to false positives, e.g. protein methyltransferase
    #sName = sName.replace("family","") #leads to false positives, e.g. arginase family, includes more than only arginase
    #sName = sName.replace("signature","") #as above
    sName = sName.replace("type","")
    sName = sName.replace("subunit","")
    sName = sName.replace("'","")
    #sName = sName.replace("putative","") #too insecure
    sName = sName.replace("profile","")
    sName = sName.replace("hypothetical","")
    sName = sName.replace("conserved","")
    sName = sName.replace("operon","")
    sName = sName.replace("active site","")
    sName = sName.replace("enzyme","")    
    sName = sName.replace("probably","")    
    sName = sName.replace("like","")
    sName = sName.replace("central","")
    sName = sName.replace("51 kd","")    
    sName = sName.replace(":"," ")
    sName = sName.replace(",","")
    sName = sName.replace("(","")
    sName = sName.replace(")","")
    sName = sName.replace("]","")
    sName = sName.replace("[","")
    sName = sName.replace("-"," ")
    sName = sName.replace("respiratory chain","")
    sName = sName.replace("c terminal","")
    sName = sName.replace("n terminal","")
    sName = sName.replace("terminal","")
    sName = sName.strip(".")
    sName = sName.replace("  "," ")
    lName = sName.split(" ")
    sName = ""
    for item in lName: #making plural singular.
        if "_" in item:continue
        #if len(item)<=1:continue
        if "tigr" in item:continue
        if item.endswith("s"):item=item[:-1]
        sName = sName+" "+item
   
    sName = sName.strip()
    lName = sName.split(" ")
    iLen = len(lName)
    if iLen>2:
        sNameNew =""
        for item in lName:        
            if len(item)<=1:continue
            sNameNew = sNameNew+" "+item
        sNameNew = sNameNew.replace("protein","") #reducing the impact, by ensuring that this name is only taken if there are more than 2 words in it
        sNameNew = sNameNew.replace("  "," ")
            
        sNameNew = sNameNew.strip()
        if sNameNew.count(" ")<=0:
            pass
            #print sNameNew
        else:
            sName = sNameNew
        
    sName = sName.replace("PEP/pyruvate binding","")    
    if sName=="kinase:" or sName=="cytochrome" or sName=="protein" or sName=="methyltransferase":sName="" #too ambigous
    if len(sName)<=3 or "binding" in sName:sName=""

    ###badly hardcoded stuff
    if sName=="prokaryotic cytidylate kinase":sName = sName.replace("prokaryotic","")
    if sName=="cytidylate kinase family":sName = sName.replace("family","")
    if sName=="glyceraldehyde phosphate dehydrogenase phosphorylating":sName = sName.replace(" phosphorylating","")
    if sName=="iron containing alcohol dehydrogenase":sName = sName.replace("iron containing ","")
    if sName=="zinc containing alcohol dehydrogenase":sName = sName.replace("zinc containing ","")
    if sName=="manganese containing catalase":sName = sName.replace("manganese containing ","")
    if sName=="pyruvate carboxyltransferase":sName = sName.replace("carboxyltransferase","carboxylase")
    if sName=="nadh ubiquinone oxidoreductase 20 kd":sName="nadh ubiquinone oxidoreductase"
    
    #if "iron" in sName and not sName in setNameTemp and bBrenda:
        #print sName
        #setNameTemp.add(sName)
       

    ###
    sName = sName.replace("  "," ")
    sName = sName.strip()
    return sName

sBrenda = "brenda_download.txt"
sAssignedECs = "protein_to_already_predicted_EC.csv"
sInterpro = "interpro.tsv"

dicECNames = dict()
inputFile = open(sBrenda)
for lines in inputFile.xreadlines():
    lines = lines.strip()
    if not lines:continue
    if len(lines)<=3:continue
    if lines[0]=="I" and lines[1]=="D" and lines[2]=="\t":        
        crap,sEC = lines.split("\t")
        #if " " in sEC:
            #if "transferred entry" in sEC:continue
            #sEC,crap = sEC.split(" ",1)
    if (lines[0]=="R" and lines[1]=="N" and lines[2]=="\t") or (lines[0]=="S" and lines[1]=="Y" and lines[2]=="\t") or  (lines[0]=="S" and lines[1]=="N" and lines[2]=="\t"): 
        crap,sName = lines.split("\t")
        sName = sName.strip()
        
        if sName[0]=="#":continue
        sName = processString(sName,bBrenda=True)
        if not sName:continue
        if len(sName)<=3:continue
        #if "methenyltetra" in sName:print sName,sEC
     
        dicECNames.setdefault(sName,sEC)
        #print sName

inputFile.close()


#was just for testing, doesn't seem possible to strip cofactors, see e.g. iron cytochrome reductase and nitrate cytochrome reductase
'''outputFile = open("EC_names_with_cofactors.csv","w")
for key,value in dicECNames.iteritems():
    if "iron" in key or "manganese" in key or  "zinc" in key or "copper" in key or "nickel" in key  or "cobalt" in key or  "molybdenum" in key or "vanadium" in key:
        outputFile.write(key+"\t"+value+"\n")
outputFile.close()'''


dicEC = dict()
inputFile = open(sAssignedECs)
for lines in inputFile.xreadlines():
    lines = lines.strip()
    prot,EC = lines.split("\t")
    if ";" in EC:
        lEC = EC.split(";")
    else:
        lEC = [EC]
    dicEC.setdefault(prot,lEC)
inputFile.close()


dicDomains = dict()
dicProtToDomain = dict()
inputFile = open(sInterpro)
for lines in inputFile.xreadlines():
    if lines[0]!="c":continue #this assumes that the names of the proteins start with c (as predicted from prodigal from IDBA output). Change it, if you need to use it.
    lStuff = lines.split("\t")
    sName = lStuff[5]
    sOldName = sName
    sName = sName.strip()
    
    if not sName:continue
    #print sName
    sName = processString(sName)
    if not sName:continue
    if len(sName)<=3:continue
    dicDomains.setdefault(lStuff[4],sName)
    #if "methenyltetrahydromethanopterin" in sName:
        #print lStuff[4]+" NAME: "+sName
    if lStuff[0] in dicProtToDomain:
        lDomains = dicProtToDomain.get(lStuff[0])
        lDomains.append(lStuff[4])
        lTemp = lDomains[:]
        dicDomains[lStuff[0]]=lTemp
    else:
        dicProtToDomain.setdefault(lStuff[0],[lStuff[4]])
inputFile.close()

iCount = 0
setFound = set()
setNamesFound = set()
outputFile = open("test_EC_mining.csv","w")
outputFileShort = open("EC_from_text_mining.csv","w")
outputNames = open("test_EC_mining_names_unique.csv","w")
for prot,lDom in dicProtToDomain.iteritems():
    if prot in dicEC:
        lEC = dicEC.get(prot)
    else:
        lEC = []

    for domain in lDom:
        sName = dicDomains.get(domain)
        if sName in dicECNames:
            sEC = dicECNames.get(sName)
            if "transferred" in sEC or "deleted" in sEC:continue
            if not sEC in lEC:
                #print prot,sName,sEC
                if " " in sEC:
                    sEC,crap = sEC.split(" ",1)
                sOut = prot+"\t"+sName+"\t"+sEC+"\n"
                sOutShort = prot+"\t"+sEC+"\n"
                if not sOutShort in setFound:
                    setFound.add(sOutShort)
                    outputFile.write(sOut)
                    outputFileShort.write(sOutShort)
                    iCount = iCount+1
                if not sName in setNamesFound:
                    setNamesFound.add(sName)
                    outputNames.write(sOut)
outputFile.close()
outputNames.close()
outputFileShort.close()
print iCount

                                   

